/*
  WiFi Modbus TCP Client Toggle POUR LIRE LE CERBO GX EN WIFI!!!!!!!!!!!!!!!!!!!!!

  VERSION FONCTIONNELLE !!!!!!!!!

  This sketch read and write(!!) the register of a Modbus TCP server Cerbo GX VICTRON connected by wifi, via router


  Circuit:
   - MKR1000 or MKR WiFi 1010 board

  created 13 october 2021
  by Jean-Luc Duhamel
*/

#include <SPI.h>
#include <WiFiNINA.h> // for MKR WiFi 1010

#include <ArduinoRS485.h> // ArduinoModbus depends on the ArduinoRS485 library
#include <ArduinoModbus.h>

#include "arduino_secrets.h"
///////please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = SECRET_SSID;        // your network SSID (name)
char pass[] = SECRET_PASS;        // your network password (use for WPA, or use as key for WEP)
int  keyIndex = 0;                // your network key Index number (needed only for WEP)

int   status = WL_IDLE_STATUS;
int   i=0;                        // number of loop
long  RegRelay2=0;                // state of relay 2 of cerbo GX
long  RegOnMultiplus=0;           // test to pilot the button of Multiplus : NOT usable


WiFiClient wifiClient;
ModbusTCPClient modbusTCPClient(wifiClient);

IPAddress server(192,168,1,246); //  IP Address of cerbo GX  !!!!!!!!!!!!!!!!!!!

void setup() {
  //Initialize serial and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  Serial.println("Modbus TCP Client Toggle WIFI");

  // attempt to connect to WiFi network:
  while (status != WL_CONNECTED) {
    Serial.print("Attempting to connect to SSID: ");
    Serial.println(ssid);
    // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
    status = WiFi.begin(ssid, pass);

    // wait 10 seconds for connection:
    delay(10000);
  }

  // you're connected now, so print out the status:
  printWifiStatus();
  Serial.println("-----fin setup");
}

void loop() {
  if (!modbusTCPClient.connected()) {
    // client not connected, start the Modbus TCP client
    Serial.println("Attempting to connect to Modbus TCP server");
    
    if (!modbusTCPClient.begin(server)) {
      Serial.println("Modbus TCP Client failed to connect!");
    } else {
      Serial.println("Modbus TCP Client connected");

      Serial.println("--connection Ok--");

        
    }
  } else {
    // client connected

    // write the value of 0x01, to the coil at address 0x00

    /*  xxxx = modbusTCPClient.holdingRegisterRead(N°appareil TCP, register);
       
     appareils TCP of my system:
     .system        : CerboGX       : 100
     .vebus         : Multiplus     : 227
     .solarcharger  : MMPT 100-50   : 223
     .solarcharger  : MPPT 100-30   : 224
     .battery       : Shamrtshunt   : 226
     .
    
    */

    long RegCerbo=0;
    Serial.print("prod du jour KWh PV :");
    RegCerbo= modbusTCPClient.holdingRegisterRead(224,784);             //id, adr 
    Serial.println(RegCerbo/10);
   
    long RegCerboU=0;
    RegCerboU= modbusTCPClient.holdingRegisterRead(224,776); 
    Serial.print("MPPT toit U="+String ((float) RegCerboU/100));
    int RegCerboI=0;
    RegCerboI= modbusTCPClient.holdingRegisterRead(224,777); 
    Serial.print("   I="+String ((float) RegCerboI/10));
    Serial.println("   P="+String ((float) RegCerboU * RegCerboI /1000));  
    
    long RegCerboChargeur30=0;
    RegCerboChargeur30= modbusTCPClient.holdingRegisterRead(224,774); 
    Serial.println("MPPT Toit On/Off="+String (RegCerboChargeur30));      //1=on,  4=off
    RegCerboChargeur30= modbusTCPClient.holdingRegisterRead(224,789); 
    Serial.println("MPPT Toit P="+String (RegCerboChargeur30/10)+"W"); 

    long RegCerboSoC=0;
    RegCerboSoC= modbusTCPClient.holdingRegisterRead(226,266); 
    Serial.print("ShuntSoC : "+String (RegCerboSoC/10)+"%    "); 
    RegCerboU= modbusTCPClient.holdingRegisterRead(226,259); 
    Serial.print("U= "+String ((float) RegCerboU/100,2)+"V    "); 
    RegCerboI= modbusTCPClient.holdingRegisterRead(226,261); 
    Serial.print("I= "+String ((float) RegCerboI/10)+"A    "); 
    RegCerboU= modbusTCPClient.holdingRegisterRead(226,260); 
    Serial.println("U vehic= "+String ((float) RegCerboU/100,2)+"V"); 
    
    RegCerboU= modbusTCPClient.holdingRegisterRead(100,840); 
    Serial.print("Cerbo U= "+String ((float) RegCerboU/10,1)+"V    "); 
    RegCerboI= modbusTCPClient.holdingRegisterRead(100,841); 
    Serial.println("I= "+String ( RegCerboI/10)+"A"); 

    //if (RegRelay2==0) RegRelay2=1; else RegRelay2=0;              //to toggle Regrelay
    //modbusTCPClient.holdingRegisterWrite(100, 807, RegRelay2); 
    //delay(500);
    RegRelay2= modbusTCPClient.holdingRegisterRead(100,807); 
    Serial.println("Relay 2 ="+String (RegRelay2));


    //if (RegOnMultiplus==3) RegOnMultiplus=1; else RegOnMultiplus=3;    //to toggle RegOnMultiplus
    if (i==5) {                                                         // toggle Multiplus at i=5, only one time
      RegOnMultiplus= modbusTCPClient.holdingRegisterRead(227,33); //1: charg only, 2: inverter, 3: On, 4:Off 
      Serial.println("Multiplus ="+String (RegOnMultiplus));  
      Serial.println("Changement d'etat Multiplus...");      
      modbusTCPClient.holdingRegisterWrite(227, 33, 1);             // doesn't work  !!!!!!!!!!!!!
      delay(500);
    }
    RegOnMultiplus= modbusTCPClient.holdingRegisterRead(227,33); //1: charg only, 2: inverter, 3: On, 4:Off 
    Serial.print("Multiplus ="+String (RegOnMultiplus));  
    RegOnMultiplus= modbusTCPClient.holdingRegisterRead(227,3);  
    Serial.print("     EDF U="+String (RegOnMultiplus/10)+"V");  
    RegOnMultiplus= modbusTCPClient.holdingRegisterRead(227,6);  
    Serial.println("    I="+String (RegOnMultiplus/10)+"A AC");  

    long RegVebusAlm=0;
    RegVebusAlm= modbusTCPClient.holdingRegisterRead(227,35); //0 ok, 1 warning, 2 Alm
    Serial.print("Vebus U low Alm= "+String (RegVebusAlm==1?"Oui":"Non"));
    RegVebusAlm= modbusTCPClient.holdingRegisterRead(227,60); //BMS error 0 no, 1 err
    Serial.println("    BMS Alm  = "+String (RegVebusAlm==1?"Oui":"Non"));


    i++;
    Serial.print(i); Serial.println("|-------------");
    // wait for 1 second
    delay(10000);

  }
}

void printWifiStatus() {
  // print the SSID of the network you're attached to:
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());

  // print your WiFi shield's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);

  // print the received signal strength:
  long rssi = WiFi.RSSI();
  Serial.print("signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");
}
